diff --git a/krita/image/kis_selection_transaction_data.h b/krita/image/kis_selection_transaction_data.h
new file mode 100644
index 0000000..5e2e3da
--- /dev/null
+++ b/krita/image/kis_selection_transaction_data.h
@@ -0,0 +1,52 @@
+/*
+ *  Copyright (c) 2005 Casper Boemann <cbr@boemann.dk>
+ *  Copyright (c) 2008 Sven Langkamp <sven.langkamp@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_SELECTION_TRANSACTION_DATA_H_
+#define KIS_SELECTION_TRANSACTION_DATA_H_
+
+#include "kis_transaction_data.h"
+
+#include "kis_selection.h"
+
+/**
+ * KisSelectionTransactionData records changes to the selection for the undo stack. There
+ * are two selections in Krita: the global selection and the per-layer selection mask.
+ * A particular action only works with one of these selections (in the future, we may
+ * want to merge the global and local selection).
+ *
+ * KisSelectionTransactionData remembers which selection was changed.
+ */
+class KRITAIMAGE_EXPORT KisSelectionTransactionData : public KisTransactionData
+{
+
+public:
+    KisSelectionTransactionData(const QString& name, KisImageWSP image, KisSelectionSP selection, QUndoCommand* parent = 0);
+    virtual ~KisSelectionTransactionData();
+
+public:
+    void redo();
+    void undo();
+
+private:
+    KisImageWSP m_image;
+    KisSelectionSP m_selection;
+    bool m_wasDeselected;
+};
+
+#endif /* KIS_SELECTION_TRANSACTION_DATA_H_ */
diff --git a/krita/image/kis_shear_visitor.h b/krita/image/kis_shear_visitor.h
index d84e00c..a98f40a 100644
--- a/krita/image/kis_shear_visitor.h
+++ b/krita/image/kis_shear_visitor.h
@@ -41,13 +41,13 @@ public:
     using KisNodeVisitor::visit;
 
     KisShearVisitor(double xshear, double yshear, KoUpdater *progress)
-            : m_xshear(xshear), m_yshear(yshear), m_progress(progress), m_strategy(0), m_undo(0) {}
+            : m_xshear(xshear), m_yshear(yshear), m_progress(progress), m_strategy(0), m_undoAdapter(0) {}
 
     void setStrategy(KisFilterStrategy* strategy) {
         m_strategy = strategy;
     }
-    void setUndoAdapter(KisUndoAdapter* undo) {
-        m_undo = undo;
+    void setUndoAdapter(KisUndoAdapter* undoAdapter) {
+        m_undoAdapter = undoAdapter;
     }
 public:
 
@@ -66,10 +66,7 @@ public:
         else
             strategy = new KisMitchellFilterStrategy;
 
-        KisTransaction* t = 0;
-
-        if (m_undo && m_undo->undo())
-            t = new KisTransaction("", dev);
+        KisTransaction transaction("", dev);
 
         //Doesn't do anything, internally transforms x and y shear to 0 each :-///
         //KisTransformWorker w(dev, 1.0, 1.0, m_xshear, m_yshear, 0, 0, 0, m_progress, strategy);
@@ -77,8 +74,10 @@ public:
 
         shear(dev, m_xshear, m_yshear, m_progress);
 
-        if (m_undo && m_undo->undo())
-            m_undo->addCommand(t);
+        if (m_undoAdapter)
+            transaction.commit(m_undoAdapter);
+        else
+            transaction.end();
 
         if (!m_strategy)
             delete strategy;
@@ -133,7 +132,7 @@ private:
     double m_yshear;
     KoUpdater* m_progress;
     KisFilterStrategy* m_strategy;
-    KisUndoAdapter* m_undo;
+    KisUndoAdapter* m_undoAdapter;
 };
 
 #endif // KIS_SHEAR_VISITOR_H_
diff --git a/krita/image/kis_transaction.h b/krita/image/kis_transaction.h
index 81d2baf..7b61d0e 100644
--- a/krita/image/kis_transaction.h
+++ b/krita/image/kis_transaction.h
@@ -1,5 +1,5 @@
 /*
- *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -19,40 +19,99 @@
 #ifndef KIS_TRANSACTION_H_
 #define KIS_TRANSACTION_H_
 
-#include <QString>
 #include <QUndoCommand>
 
 #include "kis_types.h"
 #include <krita_export.h>
 
-/**
- * A tile based undo command.
- *
- * Ordinary QUndoCommand subclasses store parameters and apply the action in
- * the redo() command, however, Krita doesn't work like this. Undo replaces
- * the current tiles in a paint device with the old tiles, redo replaces them
- * again with the new tiles without actually executing the command that changed
- * the image data again.
- */
-class KRITAIMAGE_EXPORT KisTransaction : public QObject, public QUndoCommand
-{
+#include "kis_transaction_data.h"
+#include "kis_selection_transaction_data.h"
+#include "kis_selected_transaction_data.h"
+#include "kis_paint_device.h"
 
-    Q_OBJECT
+#include "kis_undo_adapter.h"
 
+class KisTransaction
+{
 public:
+    KisTransaction(const QString& name, KisPaintDeviceSP device, QUndoCommand* parent = 0) {
+        m_transactionData = new KisTransactionData(name, device, parent);
+    }
+
+    virtual ~KisTransaction() {
+        if(m_transactionData) {
+            m_transactionData->endTransaction();
+            delete m_transactionData;
+        }
+    }
+
+    QUndoCommand* undoCommand() {
+        return m_transactionData;
+    }
+
+    void commit(KisUndoAdapter* undoAdapter) {
+        Q_ASSERT_X(m_transactionData, "KisTransaction::commit()",
+                   "the transaction has been tried to be committed twice");
+
+        m_transactionData->endTransaction();
+        undoAdapter->addCommand(m_transactionData);
+        m_transactionData = 0;
+    }
+
+    void end() {
+        Q_ASSERT_X(m_transactionData, "KisTransaction::end()",
+                   "nothing to end!");
+        m_transactionData->endTransaction();
+        delete m_transactionData;
+        m_transactionData = 0;
+    }
 
-    KisTransaction(const QString& name, KisPaintDeviceSP device, QUndoCommand* parent = 0);
-    virtual ~KisTransaction();
+    void revert() {
+        Q_ASSERT_X(m_transactionData, "KisTransaction::reverted()",
+                   "the transaction is tried to be reverted()"
+                   "after it has already been added to undo adapter");
 
+        m_transactionData->endTransaction();
+        /**
+         * FIXME: Should we emulate first redo() here?
+         */
+        m_transactionData->undo();
+        delete m_transactionData;
+        m_transactionData = 0;
+    }
+/*
+    QUndoCommand* endAndTakeUndoCommand() {
+        Q_ASSERT_X(m_transactionData, "KisTransaction::endAndTakeUndoCommand()",
+                   "the transaction has been tried to be ended twice");
+
+        m_transactionData->endTransaction();
+        QUndoCommand *command = m_transactionData;
+        m_transactionData = 0;
+        return command;
+    }
+*/
+protected:
+    KisTransaction() {}
+    KisTransactionData* m_transactionData;
+};
+
+class KisSelectedTransaction : public KisTransaction
+{
 public:
-    virtual void redo();
-    virtual void undo();
-    virtual void undoNoUpdate();
+    KisSelectedTransaction(const QString& name, KisNodeSP node, QUndoCommand* parent = 0)
+    {
+        m_transactionData = new KisSelectedTransactionData(name, node, parent);
+    }
+};
 
-private:
-    class Private;
-    Private * const m_d;
+class KisSelectionTransaction : public KisTransaction
+{
+public:
+    KisSelectionTransaction(const QString& name, KisImageWSP image, KisSelectionSP selection, QUndoCommand* parent = 0)
+    {
+        m_transactionData = new KisSelectionTransactionData(name, image, selection, parent);
+    }
 };
 
-#endif // KIS_TILE_COMMAND_H_
+#endif /* KIS_TRANSACTION_H_ */
 
diff --git a/krita/image/kis_transaction_data.cpp b/krita/image/kis_transaction_data.cpp
new file mode 100644
index 0000000..69eb743
--- /dev/null
+++ b/krita/image/kis_transaction_data.cpp
@@ -0,0 +1,116 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_transaction_data.h"
+
+#include "kis_paint_device.h"
+#include "kis_datamanager.h"
+
+#include "config-tiles.h" // For the next define
+#include KIS_MEMENTO_HEADER
+
+
+//#define DEBUG_TRANSACTIONS
+
+#ifdef DEBUG_TRANSACTIONS
+    #define DEBUG_ACTION(action) qDebug() << action << "for" << m_d->device->dataManager()
+#else
+    #define DEBUG_ACTION(action)
+#endif
+
+
+class KisTransactionData::Private
+{
+public:
+    QString name;
+    KisPaintDeviceSP device;
+    KisMementoSP memento;
+    bool firstRedo;
+    bool transactionFinished;
+};
+
+KisTransactionData::KisTransactionData(const QString& name, KisPaintDeviceSP device, QUndoCommand* parent)
+        : QUndoCommand(name, parent)
+        , m_d(new Private())
+{
+    m_d->device = device;
+    DEBUG_ACTION("Transaction started");
+    m_d->memento = device->dataManager()->getMemento();
+    m_d->firstRedo = true;
+    m_d->transactionFinished = false;
+}
+
+KisTransactionData::~KisTransactionData()
+{
+    Q_ASSERT(m_d->memento);
+    endTransaction();
+    m_d->device->dataManager()->purgeHistory(m_d->memento);
+
+    delete m_d;
+}
+
+void KisTransactionData::endTransaction()
+{
+    if(!m_d->transactionFinished) {
+        DEBUG_ACTION("Transaction ended");
+        m_d->transactionFinished = true;
+        m_d->device->dataManager()->commit();
+    }
+}
+
+void KisTransactionData::redo()
+{
+    //QUndoStack calls redo(), so the first call needs to be blocked
+    if (m_d->firstRedo) {
+        m_d->firstRedo = false;
+        return;
+    }
+
+    DEBUG_ACTION("Redo()");
+
+    Q_ASSERT(m_d->memento);
+    m_d->device->dataManager()->rollforward(m_d->memento);
+
+    QRect rc;
+    qint32 x, y, width, height;
+    m_d->memento->extent(x, y, width, height);
+    rc.setRect(x + m_d->device->x(), y + m_d->device->y(), width, height);
+
+    m_d->device->setDirty(rc);
+}
+
+void KisTransactionData::undo()
+{
+    DEBUG_ACTION("Undo()");
+
+    Q_ASSERT(m_d->memento);
+    m_d->device->dataManager()->rollback(m_d->memento);
+
+    QRect rc;
+    qint32 x, y, width, height;
+    m_d->memento->extent(x, y, width, height);
+    rc.setRect(x + m_d->device->x(), y + m_d->device->y(), width, height);
+
+    m_d->device->setDirty(rc);
+}
+
+void KisTransactionData::undoNoUpdate()
+{
+    Q_ASSERT(m_d->memento);
+    m_d->device->dataManager()->rollback(m_d->memento);
+}
diff --git a/krita/image/kis_transaction_data.h b/krita/image/kis_transaction_data.h
new file mode 100644
index 0000000..6b65aa0
--- /dev/null
+++ b/krita/image/kis_transaction_data.h
@@ -0,0 +1,57 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_TRANSACTION_DATA_H_
+#define KIS_TRANSACTION_DATA_H_
+
+#include <QUndoCommand>
+
+#include "kis_types.h"
+#include <krita_export.h>
+
+/**
+ * A tile based undo command.
+ *
+ * Ordinary QUndoCommand subclasses store parameters and apply the action in
+ * the redo() command, however, Krita doesn't work like this. Undo replaces
+ * the current tiles in a paint device with the old tiles, redo replaces them
+ * again with the new tiles without actually executing the command that changed
+ * the image data again.
+ */
+class KRITAIMAGE_EXPORT KisTransactionData : public QUndoCommand
+{
+public:
+    KisTransactionData(const QString& name, KisPaintDeviceSP device, QUndoCommand* parent = 0);
+    virtual ~KisTransactionData();
+
+public:
+    virtual void redo();
+    virtual void undo();
+
+    virtual void endTransaction();
+
+protected:
+    virtual void undoNoUpdate();
+
+private:
+    class Private;
+    Private * const m_d;
+};
+
+#endif /* KIS_TRANSACTION_DATA_H_ */
+
diff --git a/krita/image/kis_transform_visitor.h b/krita/image/kis_transform_visitor.h
index d4cfbf4..22e18f4 100644
--- a/krita/image/kis_transform_visitor.h
+++ b/krita/image/kis_transform_visitor.h
@@ -28,9 +28,8 @@
 #include "kis_group_layer.h"
 #include "kis_paint_layer.h"
 #include "kis_adjustment_layer.h"
-#include "kis_transaction.h"
 #include "kis_transform_worker.h"
-#include "kis_selected_transaction.h"
+#include "kis_transaction.h"
 #include "kis_external_layer_iface.h"
 #include "kis_undo_adapter.h"
 #include "kis_image.h"
@@ -66,11 +65,10 @@ public:
 
     bool visit(KisExternalLayer * layer) {
         KisUndoAdapter* undoAdapter = layer->image()->undoAdapter();
-        
-        QUndoCommand* cmd = layer->transform(m_sx, m_sy, 0.0, 0.0, m_angle, m_tx, m_ty);
-        if (cmd && undoAdapter && undoAdapter->undo()) {
-            undoAdapter->addCommand(cmd);
-        }
+
+        QUndoCommand* command = layer->transform(m_sx, m_sy, 0.0, 0.0, m_angle, m_tx, m_ty);
+        if (command)
+            undoAdapter->addCommand(command);
         return true;
     }
 
@@ -131,18 +129,12 @@ private:
     void transformPaintDevice(KisNode * node) {
         KisPaintDeviceSP dev = node->paintDevice();
 
-        KisTransaction * t = 0;
-        if (m_image->undo()) {
-            t = new KisTransaction(i18n("Rotate Node"), dev);
-            Q_CHECK_PTR(t);
-        }
+        KisTransaction transaction(i18n("Rotate Node"), dev);
 
         KisTransformWorker tw(dev, m_sx, m_sy, 0.0, 0.0, m_angle, m_tx, m_ty, m_progress, m_filter, true);
         tw.run();
 
-        if (m_image->undo()) {
-            m_image->undoAdapter()->addCommand(t);
-        }
+        transaction.commit(m_image->undoAdapter());
         node->setDirty();
     }
 
diff --git a/krita/image/kis_undo_adapter.cc b/krita/image/kis_undo_adapter.cc
index dc0bf6f..a1a0ff7 100644
--- a/krita/image/kis_undo_adapter.cc
+++ b/krita/image/kis_undo_adapter.cc
@@ -24,7 +24,6 @@
 
 KisUndoAdapter::KisUndoAdapter(KoDocument* doc): m_doc(doc)
 {
-    m_undo = true;
 }
 
 KisUndoAdapter::~KisUndoAdapter()
@@ -86,16 +85,6 @@ void KisUndoAdapter::undoLastCommand()
     m_doc->undoStack()->undo();
 }
 
-void KisUndoAdapter::setUndo(bool undo)
-{
-    m_undo = undo;
-}
-
-bool KisUndoAdapter::undo() const
-{
-    return m_undo;
-}
-
 void KisUndoAdapter::beginMacro(const QString& macroName)
 {
     m_doc->beginMacro(macroName);
diff --git a/krita/image/kis_undo_adapter.h b/krita/image/kis_undo_adapter.h
index 36690b2..ed9201d 100644
--- a/krita/image/kis_undo_adapter.h
+++ b/krita/image/kis_undo_adapter.h
@@ -62,8 +62,6 @@ public:
     virtual const QUndoCommand * presentCommand();
     virtual void addCommand(QUndoCommand *cmd);
     virtual void undoLastCommand();
-    virtual void setUndo(bool undo);
-    virtual bool undo() const;
 
     /// XXX: is this actually threadsafe?
     virtual void beginMacro(const QString& macroName);
@@ -82,7 +80,6 @@ private:
 
     QVector<KisCommandHistoryListener*> m_undoListeners;
     KoDocument* m_doc;
-    bool m_undo;
 };
 
 
diff --git a/krita/image/recorder/kis_recorded_filter_action.cpp b/krita/image/recorder/kis_recorded_filter_action.cpp
index c63d103..f65839a 100644
--- a/krita/image/recorder/kis_recorded_filter_action.cpp
+++ b/krita/image/recorder/kis_recorded_filter_action.cpp
@@ -92,10 +92,8 @@ void KisRecordedFilterAction::play(KisNodeSP node, const KisPlayInfo& info) cons
     foreach(KisNodeSP node, nodes) {
         KisPaintDeviceSP dev = node->paintDevice();
         KisLayerSP layer = dynamic_cast<KisLayer*>(node.data());
-        KisTransaction * cmd = 0;
-        if (info.undoAdapter()) cmd = new KisTransaction(d->filter->name(), dev);
-
         QRect r1 = dev->extent();
+        KisTransaction transaction(d->filter->name(), dev);
 
         // Ugly hack to get at the image without bloating the node interface
         KisImageWSP image;
@@ -108,7 +106,8 @@ void KisRecordedFilterAction::play(KisNodeSP node, const KisPlayInfo& info) cons
 
         d->filter->process(dev, r1, kfc);
         node->setDirty(r1);
-        if (info.undoAdapter()) info.undoAdapter()->addCommand(cmd);
+
+        transaction.commit(info.undoAdapter());
     }
 }
 
diff --git a/krita/image/recorder/kis_recorded_paint_action.cpp b/krita/image/recorder/kis_recorded_paint_action.cpp
index bdbedae..af84c94 100644
--- a/krita/image/recorder/kis_recorded_paint_action.cpp
+++ b/krita/image/recorder/kis_recorded_paint_action.cpp
@@ -270,8 +270,7 @@ void KisRecordedPaintAction::play(KisNodeSP node, const KisPlayInfo& info) const
     QList<KisNodeSP> nodes = nodeQueryPath().queryNodes(info.image(), info.currentNode());
     foreach(KisNodeSP node, nodes) {
         dbgUI << "Play recorded paint action on node : " << node->name() ;
-        KisTransaction * cmd = 0;
-        if (info.undoAdapter()) cmd = new KisTransaction("", node->paintDevice());
+        KisTransaction transaction("", node->paintDevice());
 
         KisPaintDeviceSP target = 0;
         if (d->paintIncremental) {
@@ -326,9 +325,11 @@ void KisRecordedPaintAction::play(KisNodeSP node, const KisPlayInfo& info) const
             node->setDirty(painter->dirtyRegion());
         }
         delete painter;
-        if (info.undoAdapter()) info.undoAdapter()->addCommand(cmd);
+
         if (d->paintOpPreset)
             d->paintOpPreset->settings()->setNode(0);
+
+        transaction.commit(info.undoAdapter());
     }
 }
 
diff --git a/krita/image/tests/kis_filter_selections_benchmark.cpp b/krita/image/tests/kis_filter_selections_benchmark.cpp
index a47b7d2..dffb880 100644
--- a/krita/image/tests/kis_filter_selections_benchmark.cpp
+++ b/krita/image/tests/kis_filter_selections_benchmark.cpp
@@ -256,7 +256,7 @@ void KisFilterSelectionsBenchmark::testBitBltWOSelections(int num)
         painter.beginTransaction("");
         painter.setCompositeOp(projection->colorSpace()->compositeOp(COMPOSITE_ALPHA_DARKEN));
         painter.bitBlt(filterRect.topLeft(), cacheDevice, filterRect);
-        delete painter.endTransaction();
+        painter.deleteTransaction();
     }
     avTime = double(timer.elapsed()) / num;
 
@@ -291,7 +291,7 @@ void KisFilterSelectionsBenchmark::testBitBltSelections(int num)
         gc.setCompositeOp(projection->colorSpace()->compositeOp(COMPOSITE_ALPHA_DARKEN));
         gc.setSelection(m_selection);
         gc.bitBlt(filterRect.topLeft(), cacheDevice, filterRect);
-        delete gc.endTransaction();
+        gc.deleteTransaction();
     }
     avTime = double(timer.elapsed()) / num;
 
diff --git a/krita/image/tests/kis_paint_device_test.cpp b/krita/image/tests/kis_paint_device_test.cpp
index a79dfa9..146f3b0 100644
--- a/krita/image/tests/kis_paint_device_test.cpp
+++ b/krita/image/tests/kis_paint_device_test.cpp
@@ -418,7 +418,9 @@ void KisPaintDeviceTest::testDeviceDuplication()
     KisTransaction transaction1("", device);
 //    qDebug()<<"CLEARING";
     device->clear(clearRect);
-    transaction1.undo();
+
+    transaction1.revert();
+
     resultImage = device->convertToQImage(0);
     QVERIFY(resultImage == referenceImage);
 
@@ -427,7 +429,9 @@ void KisPaintDeviceTest::testDeviceDuplication()
     KisTransaction transaction("", clone);
 //    qDebug()<<"CLEARING";
     clone->clear(clearRect);
-    transaction.undo();
+
+    transaction.revert();
+
     resultImage = clone->convertToQImage(0);
     QVERIFY(resultImage == referenceImage);
 
diff --git a/krita/image/tests/kis_selected_transaction_test.cpp b/krita/image/tests/kis_selected_transaction_test.cpp
index e3951a8..fe9ab97 100644
--- a/krita/image/tests/kis_selected_transaction_test.cpp
+++ b/krita/image/tests/kis_selected_transaction_test.cpp
@@ -19,7 +19,7 @@
 #include "kis_selected_transaction_test.h"
 
 #include <qtest_kde.h>
-#include "kis_selected_transaction.h"
+#include "kis_transaction.h"
 #include <KoColorSpace.h>
 #include "kis_image.h"
 #include "kis_paint_layer.h"
@@ -39,6 +39,5 @@ void KisSelectedTransactionTest::testCreation()
 
 }
 
-
 QTEST_KDEMAIN(KisSelectedTransactionTest, GUI)
 #include "kis_selected_transaction_test.moc"
diff --git a/krita/image/tests/kis_transaction_test.cpp b/krita/image/tests/kis_transaction_test.cpp
index 989e072..c87ef54 100644
--- a/krita/image/tests/kis_transaction_test.cpp
+++ b/krita/image/tests/kis_transaction_test.cpp
@@ -29,9 +29,32 @@
 #include "kis_paint_device.h"
 #include "kis_transaction.h"
 
+class KisTestingUndoAdapter : public KisUndoAdapter
+{
+public:
+    KisTestingUndoAdapter()
+        : KisUndoAdapter(0)
+    {}
+
+    void addCommand(QUndoCommand *command) {
+        m_stack.push(command);
+    }
+
+    void undo() {
+        m_stack.undo();
+    }
+
+    void redo() {
+        m_stack.redo();
+    }
+
+private:
+    QUndoStack m_stack;
+};
+
 void KisTransactionTest::testUndo()
 {
-    QUndoStack stack;
+    KisTestingUndoAdapter undoAdapter;
 
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
     KisPaintDeviceSP dev = new KisPaintDevice(cs);
@@ -50,9 +73,8 @@ void KisTransactionTest::testUndo()
     QVERIFY(c1 == Qt::white);
     QVERIFY(c2 == Qt::black);
 
-    KisTransaction* t = new KisTransaction("mirror", dev, 0);
+    KisTransaction transaction("mirror", dev, 0);
     KisTransformWorker::mirrorX(dev);
-    stack.push(t);
 
     dev->pixel(5, 5, &c1);
     dev->pixel(517, 5, &c2);
@@ -60,7 +82,8 @@ void KisTransactionTest::testUndo()
     QVERIFY(c1 == Qt::black);
     QVERIFY(c2 == Qt::white);
 
-    t->undo();
+    transaction.commit(&undoAdapter);
+    undoAdapter.undo();
 
     dev->pixel(5, 5, &c1);
     dev->pixel(517, 5, &c2);
@@ -72,7 +95,7 @@ void KisTransactionTest::testUndo()
 
 void KisTransactionTest::testRedo()
 {
-    QUndoStack stack;
+    KisTestingUndoAdapter undoAdapter;
 
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
     KisPaintDeviceSP dev = new KisPaintDevice(cs);
@@ -91,9 +114,8 @@ void KisTransactionTest::testRedo()
     QVERIFY(c1 == Qt::white);
     QVERIFY(c2 == Qt::black);
 
-    KisTransaction* t = new KisTransaction("mirror", dev, 0);
+    KisTransaction transaction("mirror", dev, 0);
     KisTransformWorker::mirrorX(dev);
-    stack.push(t);
 
     dev->pixel(5, 5, &c1);
     dev->pixel(517, 5, &c2);
@@ -101,7 +123,8 @@ void KisTransactionTest::testRedo()
     QVERIFY(c1 == Qt::black);
     QVERIFY(c2 == Qt::white);
 
-    t->undo();
+    transaction.commit(&undoAdapter);
+    undoAdapter.undo();
 
     dev->pixel(5, 5, &c1);
     dev->pixel(517, 5, &c2);
@@ -109,7 +132,7 @@ void KisTransactionTest::testRedo()
     QVERIFY(c1 == Qt::white);
     QVERIFY(c2 == Qt::black);
 
-    t->redo();
+    undoAdapter.redo();
 
     dev->pixel(5, 5, &c1);
     dev->pixel(517, 5, &c2);
diff --git a/krita/image/tests/kis_transform_worker_test.cpp b/krita/image/tests/kis_transform_worker_test.cpp
index aec8481..f7b9a81 100644
--- a/krita/image/tests/kis_transform_worker_test.cpp
+++ b/krita/image/tests/kis_transform_worker_test.cpp
@@ -127,7 +127,7 @@ void KisTransformWorkerTest::testMirrorTransaction()
     QVERIFY(c2 == Qt::black);
     dev->convertToQImage(0, 0, 0, 1024, 512).save("transaction_before.png");
 
-    KisTransaction* t = new KisTransaction("mirror", dev, 0);
+    KisTransaction transaction1("mirror", dev);
     KisTransformWorker::mirrorX(dev);
 
     dev->pixel(5, 5, &c1);
@@ -149,7 +149,9 @@ void KisTransformWorkerTest::testMirrorTransaction()
     QVERIFY(c1 == Qt::white);
     QVERIFY(c2 == Qt::black);
 
-    KisTransaction* t2 = new KisTransaction("mirror", dev, 0);
+    transaction1.end();
+
+    KisTransaction transaction2("mirror", dev);
     KisTransformWorker::mirrorY(dev);
     dev->convertToQImage(0, 0, 0, 1024, 512).save("transaction_mirror_y.png");
 
@@ -159,17 +161,16 @@ void KisTransformWorkerTest::testMirrorTransaction()
     QVERIFY(c1 == Qt::black);
     QVERIFY(c2 == Qt::white);
 
+    transaction2.end();
 
     {
         QImage image(QString(FILES_DATA_DIR) + QDir::separator() + "mirror_source.png");
         KisPaintDeviceSP dev2 = new KisPaintDevice(cs);
         dev2->convertFromQImage(image, "");
-        KisTransaction t("mirror", dev2, 0);
+        KisTransaction t("mirror", dev2);
         KisTransformWorker::mirrorX(dev2);
         dev2->convertToQImage(0, 0, 0, image.width(), image.height()).save("mirror_test_t_2.png");
     }
-    delete t;
-    delete t2;
 }
 
 
diff --git a/krita/image/tiles3/kis_memento.h b/krita/image/tiles3/kis_memento.h
index 9c09b67..7698413 100644
--- a/krita/image/tiles3/kis_memento.h
+++ b/krita/image/tiles3/kis_memento.h
@@ -75,16 +75,16 @@ public:
         return false; // Compiller would be happy! =)
     }
 
+
     /**
-     * Some tricky equivalet to 'commit()'
-     * FIXME: do a usual commit instead
+     * Not used, happily
      */
-    inline bool valid() const {
-        return m_valid;
-    }
-    inline void setInvalid() {
-        m_valid = false;
-    }
+//    inline bool valid() const {
+//        return m_valid;
+//    }
+//    inline void setInvalid() {
+//        m_valid = false;
+//    }
 
 private:
     friend class KisMementoManager;
